/********************************************************************************
*                                                                               *
*                  ODBC Database connector                                      *
*                                                                               *
*********************************************************************************
* Copyright (C) 2002 by Mathew Robertson.       All Rights Reserved.            *
* Copyright (C) 2002 by Giancarlo Formicuccia.  All Rights Reserved.            *
*********************************************************************************
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.    *
*********************************************************************************/
#ifndef FXODBC_H
#define FXODBC_H

#ifndef FXDATABASEINTERFACE_H
#include "FXDatabaseInterface.h"
#endif
namespace FXEX {

/**
 * ODBC datasource connection/driver
 */
class FXODBC: public FXDatabaseInterface {
  FXDECLARE(FXODBC)

protected:
  /// serialisation
  FXODBC();

public:
  /// ctor
  FXODBC(FXApp *a,FXObject *tgt=NULL,FXSelector sel=0);

  /// connect to ODBC datasource
  virtual FXbool connect() {}

  /// children implement a real disconnect method
  virtual void disconnect() {}

  /// implement real query mechanism
  virtual FXbool query(const FXString& qry) {}

  /// this returns a list of tables implemented for this database
  virtual FXStringList getTables() {}

  /// create resources
  virtual void create();

  /// Stream save and load
  virtual void save(FXStream& store) const;
  virtual void load(FXStream& store);

  /// dtor
  virtual ~FXODBC();
  };

} // namespace FXEX
#endif // FXODBC_H
