/********************************************************************************
*                                                                               *
*                  Socket Stream                                                *
*                                                                               *
*********************************************************************************
* Copyright (C) 2002 by Mathew Robertson.   All Rights Reserved.                *
*********************************************************************************
* This library is free software; you can redistribute it and/or                 *
* modify it under the terms of the GNU Lesser General Public                    *
* License as published by the Free Software Foundation; either                  *
* version 2.1 of the License, or (at your option) any later version.            *
*                                                                               *
* This library is distributed in the hope that it will be useful,               *
* but WITHOUT ANY WARRANTY; without even the implied warranty of                *
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU             *
* Lesser General Public License for more details.                               *
*                                                                               *
* You should have received a copy of the GNU Lesser General Public              *
* License along with this library; if not, write to the Free Software           *
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA.    *
*********************************************************************************/
#ifndef FXSOCKETSTREAM_H
#define FXSOCKETSTREAM_H

// FIXME this should really be made generic and called FXIOStream, so as to use the
//       virtual methods of the FXIOHandle class

#ifndef FXSTREAM_H
#include <fox/FXStream.h>
using namespace FX;
#endif
namespace FXEX {
class FXSocket;

/**
 * A first implementation of a socket stream
 */
class FXAPI FXSocketStream : public FXStream {

  protected:
    FXSocket *socket;  // handle to actual socket
    FXbool    opened;  // did this stream open the socket

  protected:
    // serialisation
    FXSocketStream(){}

    /// save data to socket
    void saveItems(const void* buf,unsigned long n);

    /// load data from socket
    void loadItems(void* buf,unsigned long n);

  public:
    /// Create a socket stream based on a specific socket
    FXSocketStream(const FXObject *cont=NULL);

    /// open a socket stream - socket will be opened if not already opened
    FXbool open(FXSocket *sock,FXStreamDirection save_or_load);

    /// close a socket stream
    FXbool close();

    /// dtor
    virtual ~FXSocketStream();
  };

} // namespace FXEX
#endif // FXIOSTREAM_H
