#include <fox/fxver.h>
#include <fox/xincs.h>
#include <fox/fxdefs.h>
#include <fox/FXStream.h>
#include <fox/FXString.h>
#include <fox/FXSize.h>
#include <fox/FXPoint.h>
#include <fox/FXRectangle.h>
#include <fox/FXRegistry.h>
#include <fox/FXApp.h>
using namespace FX;
#include "fxexdefs.h"
#include "FXArray.h"
#include "FXDatabaseInterface.h"
#include "FXDatabaseQuery.h"
using namespace FXEX;
namespace FXEX {

// map
FXDEFMAP(FXDatabaseQuery) FXDatabaseQueryMap[]={
  FXMAPFUNC(SEL_COMMAND,FXDatabaseQuery::ID_MOVE_FIRST,FXDatabaseQuery::onMoveFirst),
  FXMAPFUNC(SEL_COMMAND,FXDatabaseQuery::ID_MOVE_NEXT,FXDatabaseQuery::onMoveNext),
  FXMAPFUNC(SEL_COMMAND,FXDatabaseQuery::ID_MOVE_PREVIOUS,FXDatabaseQuery::onMovePrevious),
  FXMAPFUNC(SEL_COMMAND,FXDatabaseQuery::ID_MOVE_LAST,FXDatabaseQuery::onMoveLast),
  FXMAPFUNC(SEL_COMMAND,FXDatabaseQuery::ID_MOVE_TO,FXDatabaseQuery::onMoveTo),
  };
FXIMPLEMENT(FXDatabaseQuery,FXBaseObject,FXDatabaseQueryMap,ARRAYNUMBER(FXDatabaseQueryMap))

// serialisation
FXDatabaseQuery::FXDatabaseQuery() : FXBaseObject() {}

// ctor
FXDatabaseQuery::FXDatabaseQuery(FXApp *a,FXDatabaseInterface *dbi,const FXString& qry,FXObject *tgt,FXSelector sel):FXBaseObject(a,tgt,sel){
  database=dbi;
  query=qry;
  }

// dtor
FXDatabaseQuery::~FXDatabaseQuery(){
  database=(FXDatabaseInterface*)-1;
  }

// save resouces to stream
void FXDatabaseQuery::save(FXStream& store) const {
  FXBaseObject::save(store);
  store << database;
  store << query;
  }

// load resources from stream
void FXDatabaseQuery::load(FXStream& store){
  FXBaseObject::load(store);
  store >> database;
  store >> query;
  }

// set to new database
void FXDatabaseQuery::setDatabase(FXDatabaseInterface *dbi){
  database=dbi;
  }

// set query to new query string
void FXDatabaseQuery::setQuery(const FXString& qry){
  query=qry;
  }

// execute query
FXbool FXDatabaseQuery::execute(){
  if(!database->isConnected() && !database->connect()) {
    fxwarning("%s: database is not connected\n",getClassName());
    return FALSE;
    }
  return database->query(query);
  }

// handle move of row pointer, to first row
long FXDatabaseQuery::onMoveFirst(FXObject*,FXSelector,void*){
  return 1;
  }

// handle move of row pointer, to next row
long FXDatabaseQuery::onMoveNext(FXObject*,FXSelector,void*){
  return 1;
  }

// handle move of row pointer, to prev row
long FXDatabaseQuery::onMovePrevious(FXObject*,FXSelector,void*){
  return 1;
  }

// handle move of row pointer, to last row
long FXDatabaseQuery::onMoveLast(FXObject*,FXSelector,void*){
  return 1;
  }

// handle move of row pointer, to specified row
long FXDatabaseQuery::onMoveTo(FXObject*,FXSelector,void*){
  return 1;
  }

}
