#include <stdio.h>
#include <stdlib.h>
#include <windows.h>

#define COM1 "\\\\.\\COM1"

#define SAT_NONE    0
#define SAT_GMS     1
#define SAT_GOES09  2
#define SAT_NOAA12  3
#define SAT_NOAA14  4
#define SAT_NOAA15  5
#define SAT_NOAA16  6
#define SAT_NOAA17  7
#define SAT_FY1C    8
#define SAT_FY1D    9
#define SAT_FY2B    10
#define SAT_PARK    99

int sat_type=3DSAT_GOES09;

void error_exit(const char* msg){
  printf("%s\n",msg);
  exit(1);
  }

// send a text string down the serial port
BOOL sendmsg(HANDLE port,const char* msg){
  DWORD nwritten=3D0;
  char buf[20];
  int len;
  BOOL result;
  buf[19]=3D0;

  strcpy(buf,msg);
  strcat(buf,"\r");
  len=3Dstrlen(buf);
  result=3DWriteFile(port,msg,len,&nwritten,NULL);
  sleep(1);
  if (nwritten < len) {
    printf("Error writing '%s' to port\n",buf);
    return FALSE;
    }
  return result;
  }

int parse_args(int argc,char *argv[]){
  if (argc>1){
    if ((strstr(argv[1],"gms") !=3D 0)||(strstr(argv[1],"GMS") !=3D 0)) {
      sat_type =3D SAT_GMS;
      puts ("Sat type set to GMS");
      }
    if ((strstr(argv[1],"goes09") !=3D 0)||(strstr(argv[1],"GOES09") =
!=3D 0)) {=0A=
      sat_type =3D SAT_GOES09;=0A=
      puts ("Sat type set to GOES-09");=0A=
      }=0A=
    if ((strstr(argv[1],"noaa12") !=3D 0)||(strstr(argv[1],"NOAA12") =
!=3D 0)) {=0A=
      sat_type =3D SAT_NOAA12;=0A=
      puts ("Sat type set to NOAA-12");=0A=
      }=0A=
    if ((strstr(argv[1],"noaa14") !=3D 0)||(strstr(argv[1],"NOAA14") =
!=3D 0)) {=0A=
      sat_type =3D SAT_NOAA14;=0A=
      puts ("Sat type set to NOAA-14");=0A=
      }=0A=
    if ((strstr(argv[1],"noaa15") !=3D 0)||(strstr(argv[1],"NOAA15") =
!=3D 0)) {=0A=
      sat_type =3D SAT_NOAA15;=0A=
      puts ("Sat type set to NOAA-15");=0A=
      }=0A=
    if ((strstr(argv[1],"noaa16") !=3D 0)||(strstr(argv[1],"NOAA16") =
!=3D 0)) {=0A=
      sat_type =3D SAT_NOAA16;=0A=
      puts ("Sat type set to NOAA-16");=0A=
      }=0A=
    if ((strstr(argv[1],"noaa17") !=3D 0)||(strstr(argv[1],"NOAA17") =
!=3D 0)) {=0A=
      sat_type =3D SAT_NOAA17;=0A=
      puts ("Sat type set to NOAA-17");=0A=
      }=0A=
    if ((strstr(argv[1],"fy1") !=3D 0)||(strstr(argv[1],"fy1") !=3D 0)) {=0A=
      sat_type =3D SAT_FY1C;=0A=
      puts ("Sat type set to FY1C");=0A=
      }=0A=
    if ((strstr(argv[1],"fy2") !=3D 0)||(strstr(argv[1],"FY2") !=3D 0)) {=0A=
      sat_type =3D SAT_FY2B;=0A=
      puts ("Sat type set to FY2B");=0A=
      }=0A=
    if ((strstr(argv[1],"park") !=3D 0)||(strstr(argv[1],"PARK") !=3D =
0)) {=0A=
      sat_type =3D SAT_PARK;=0A=
      puts ("Sat type set to PARK");=0A=
      }=0A=
    }=0A=
  return argc;=0A=
  }=0A=
=0A=
// set the local oscillator frequency=0A=
int set_osc(HANDLE port,const char* msg){=0A=
  char buf[20];=0A=
  strcpy(buf,"o");=0A=
  strcat(buf,msg);=0A=
  return sendmsg(port,buf);=0A=
  }=0A=
=0A=
// set the display frequency=0A=
int set_frq(HANDLE port,const char* msg){=0A=
  char buf[20];=0A=
  strcpy(buf,"f");=0A=
  strcat(buf,msg);=0A=
  return sendmsg(port,buf);=0A=
  }=0A=
=0A=
// set the modulation type=0A=
int set_mod(HANDLE port,const char* msg){=0A=
  char buf[20];=0A=
  strcpy(buf,"m");=0A=
  strcat(buf,msg);=0A=
  return sendmsg(port,buf);=0A=
  }=0A=
=0A=
/////////////////////////////// main ///////////////////////////=0A=
int main(int argc,char *argv[]){=0A=
=0A=
  HANDLE port;=0A=
  DCB devicestate;=0A=
  char FRQ[20];=0A=
  char OSC[20];=0A=
  char MOD[20];=0A=
  argc=3Dparse_args(argc,argv);=0A=
=0A=
  // open the serial device=0A=
  port =3D =
CreateFile(COM1,FILE_ALL_ACCESS,0,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMA=
L,NULL);=0A=
  if ( port =3D=3D INVALID_HANDLE_VALUE ) error_exit("Could not open =
serial port");=0A=
=0A=
  // setup port=0A=
  BuildCommDCB("baud=3D9600 parity=3DN data=3D8 stop=3D1",&devicestate);=0A=
  if (! SetCommState(port,&devicestate)) error_exit("Failed setting up =
COM1");=0A=
=0A=
  // set Qurom receiver parameters=0A=
  switch(sat_type){=0A=
    case SAT_GMS:=0A=
      strcpy(FRQ,"1687.100");=0A=
      strcpy(OSC,"1556.000");=0A=
      strcpy(MOD,"s");=0A=
      break;=0A=
    case SAT_GOES09:=0A=
      strcpy(FRQ,"1685.700");=0A=
      strcpy(OSC,"1550.000");=0A=
      strcpy(MOD,"g");=0A=
      break;=0A=
    case SAT_NOAA12:=0A=
      strcpy(FRQ,"1698.000");=0A=
      strcpy(OSC,"1550.000");=0A=
      strcpy(MOD,"h");=0A=
      break;=0A=
    case SAT_NOAA14:=0A=
      strcpy(FRQ,"1707.000");=0A=
      strcpy(OSC,"1550.000");=0A=
      strcpy(MOD,"h");=0A=
      break;=0A=
    case SAT_NOAA15:=0A=
      strcpy(FRQ,"1702.500");=0A=
      strcpy(OSC,"1550.000");=0A=
      strcpy(MOD,"h");=0A=
      break;=0A=
    case SAT_NOAA16:=0A=
      strcpy(FRQ,"1698.000");=0A=
      strcpy(OSC,"1550.000");=0A=
      strcpy(MOD,"h");=0A=
      break;=0A=
    case SAT_NOAA17:=0A=
      strcpy(FRQ,"1707.000");=0A=
      strcpy(OSC,"1550.000");=0A=
      strcpy(MOD,"h");=0A=
      break;=0A=
    case SAT_FY1C:=0A=
      strcpy(FRQ,"1700.400");=0A=
      strcpy(OSC,"1550.000");=0A=
      strcpy(MOD,"c");=0A=
      break;=0A=
    case SAT_FY1D:=0A=
      strcpy(FRQ,"1700.400");=0A=
      strcpy(OSC,"1550.000");=0A=
      strcpy(MOD,"c");=0A=
      break;=0A=
    case SAT_FY2B:=0A=
      strcpy(FRQ,"1682.500");=0A=
      strcpy(OSC,"1550.000");=0A=
      strcpy(MOD,"s");=0A=
      break;=0A=
    default:=0A=
      strcpy(FRQ,"1700.000");=0A=
      strcpy(OSC,"1550.000");=0A=
      strcpy(MOD,"s");=0A=
      break;=0A=
    }=0A=
=0A=
  // forward parameters to Qurom receiver=0A=
  sendmsg(port,"i0");=0A=
  set_osc(port,OSC);=0A=
  set_frq(port,FRQ);=0A=
  set_mod(port,MOD);=0A=
=0A=
  // cleanup=0A=
  CloseHandle(port);=0A=
  return 0;=0A=
  }=0A=
=0A=

------=_NextPart_000_0001_01C24282.98F41570--


